#include <stdio.h>
#include "pforth.h"

#define DEFAULT_RETURN_DEPTH (512)
#define DEFAULT_USER_DEPTH (512)
#define DEFAULT_HEADER_SIZE (120000)
#define DEFAULT_CODE_SIZE (300000)

#define INBUFSZ 1024

#define TOUCH(argument) ((void)argument)

int printk()
{
    fputs("printk\n", stderr);
}


#define SCRIPT_LEN 1024
int Scriptindex;

char *OutScript;
int OutScriptindex = 0;
int OutScriptalloc = SCRIPT_LEN;

char *InScript;

int main()
{
    char *bigbuf = NULL;
    char inbuf[INBUFSZ];

    bigbuf = (char *)strdup("");
    while (fgets(inbuf, INBUFSZ - 1, stdin) != NULL) 
    {
	char *cp = (char *)malloc(INBUFSZ + strlen(bigbuf) + 1);
	cp = strcpy(cp, bigbuf);
	cp = (char *)strcat(cp, inbuf);
	free(bigbuf);
	bigbuf = cp;      
    }

    OutScript = (char *)malloc(SCRIPT_LEN);
    InScript = strdup(bigbuf);
    dostuff(bigbuf);
    printf("RESULT: '%s'\n", OutScript);
    printf("bigbuf is '%s'\n", bigbuf);
}

int dostuff(char *Script)
{
    cfTaskData *cftd;
    cfDictionary *dic;
    int32 Result = 0;
    int32 IfInit = 0;
    ExecToken  EntryPoint = 0;
    const char *DicName = "/usr/lib/pforth/pforth.dic";

    pfInitGlobals();
/* Allocate forth Task structure. */
    cftd = pfCreateTask( DEFAULT_USER_DEPTH, DEFAULT_RETURN_DEPTH );
    
    if (cftd)
    {
	pfSetCurrentTask( cftd );
	TOUCH(IfInit);
	{
	    dic = pfLoadDictionary( DicName, &EntryPoint );
	}
	if( dic == NULL ) goto error;
	
	pfExecByName("AUTO.INIT");
	
	if(EntryPoint != 0)
	{
	    pfExecuteToken( EntryPoint );
	}
	Result = pfRunForth();
    }

    return 0;  /* success */
    
error:
    return Result;
}

#define kfree(x) free(x)


int sdTerminalIn()
{
    int c;
    if (InScript == NULL)
	return EOF;
    
    if (*InScript == '\0')
    {
	InScript = NULL;
	return EOF;
    }
    c = *InScript;
    InScript ++;    
    return c;
}

int sdTerminalOut(char c)
{
    char *newscript;
    OutScriptindex ++;
    if (OutScriptindex >= OutScriptalloc)
    {
	newscript = malloc(OutScriptindex + SCRIPT_LEN);
	memcpy(newscript, OutScript, OutScriptindex);
	kfree (OutScript);
	OutScript = newscript;
    } 
    OutScript[OutScriptindex - 1] = c;
    return c;
}

int sdTerminalFlush(void)
{
    return 0;
}
